Sub Main

    if Session.Property("%MyScriptBreak") = "1" AND Session.Property("AdminUser") then
       Stop
    End If

    if Session.Property("%MyCreateDump") = "1" AND Session.Property("AdminUser") then
       Call Dump(Session.Database)
    End If

End Sub



Sub Dump(objDB)

    Dim objView '/* View
    Dim objRec '/* Record
    Dim fso '/* FileSystemObject
    Dim tempFolderName '/* String

    '/* Ordner bestimmen und erstellen
    Set fso = CreateObject("Scripting.FileSystemObject")
    tempFolderName = fso.BuildPath(fso.GetSpecialFolder(2).Path, "MsiDump")

    If fso.FolderExists(tempFolderName) = False Then
        fso.CreateFolder (tempFolderName)
    End If

    '/* Open View
    Set objView = objDB.OpenView("SELECT `Name` FROM `_Tables`")
    objView.Execute

    '/* Iteration
    Set objRec = objView.Fetch
    
    While Not objRec Is Nothing
    
        Dim tableName '/* String
        tableName = objRec.StringData(1)
        
        Call DumpTable(objDB, tableName, tempFolderName)
    
        Set objRec = objView.Fetch
    Wend
    
    '/* Terminate
    objView.Close
    Set objRec = Nothing
    Set objView = Nothing
    
End Sub

Sub DumpTable(objDB, tableName, outputFolderName)

    Dim fso '/* FileSystemObject
    Dim objView '/* WindowsInstaller.View
    Dim objTextStream '/* TextStream
    Dim objRecordInfo '/* Record
    Dim objRecordText '/* Record
    Dim objRecordData '/* Record
    Dim ColumnCount '/* Integer
    Dim query '/* String
    Dim i '/* Integer
    
    query = "SELECT * FROM `" & tableName & "`"

    Set fso = CreateObject("Scripting.FileSystemObject")
    Set objTextStream = fso.CreateTextFile(fso.BuildPath(outputFolderName, tableName + ".csv"), True)
    
    Set objView = objDB.OpenView(query)
        
    '/* Spalten bestimmen
    Set objRecordInfo = objView.ColumnInfo(1)
    Set objRecordText = objView.ColumnInfo(0)
    ColumnCount = objRecordInfo.FieldCount
    
    
    For i = 1 To ColumnCount 
        objTextStream.Write objRecordText.StringData(i) + ";"
    Next
    objTextStream.WriteLine
    
    For i = 1 To ColumnCount 
        objTextStream.Write objRecordInfo.StringData(i) + ";"
    Next
    objTextStream.WriteLine
    
    '/* Execute
    objView.Execute
    
    Set objRecordData = objView.Fetch
    
    While Not objRecordData Is Nothing
    
        For i = 1 To ColumnCount 
            Dim szValue '/* String
            
            If UCase(Left(objRecordInfo.StringData(i), 1)) = "V" Then
                szValue = "[Binary]"
            Else
                szValue = objRecordData.StringData(i)
            End If

	    szValue = Replace(szValue, ";", "-")
            
            objTextStream.Write szValue + ";"
            
        Next
        objTextStream.WriteLine
        
        Set objRecordData = objView.Fetch
    
    Wend
    
    objView.Close
    objTextStream.Close

End Sub