'**************************************************************************
'*
'* Filename:     CAClass.vb
'* Author:       Andreas Kerl (andreaskerl@msn.com)
'*               http://www.microsoft.com/germany/
'*
'* Description:  Implementation for accessing the Windows Installer functionality
'*				
'*
'*
'* Copyright 2005, Andreas Kerl
'* 
'**************************************************************************/

''' <summary>
''' Implementation for accessing the Windows Installer functionality
''' </summary>
Public Class CAClass
    
		#Region "Constants"
		''' <summary>
		''' The action completed successfully
		''' </summary>
		private const ERROR_SUCCESS As Integer = 0

		''' <summary>
		''' The user cancels installation.
		''' </summary>
		private const ERROR_INSTALL_USEREXIT As Integer = 1602

		''' <summary>
		''' A fatal error occurred during installation.
		''' </summary>
		private const ERROR_INSTALL_FAILURE As Integer = 1603

		#End Region

		#Region "Methods"
		''' <summary>
		''' Sample method for accessing Windows Installer functionality
		''' </summary>
		''' <param name="hSession">Windows Installer Session</param>
		''' <returns>Custom Action Return Value</returns>
		<DllExportAttribute()> _
		Public Shared Function Foo(ByVal hSession As Integer) As Integer
			' Implementation
			return (ERROR_SUCCESS)
		End Function
		#End Region

End Class

