#include "stdafx.h"


////////////////////////////////////////////////////////////////////////////
/// Funktion zum berprfen des Installationsverzeichnisses von Outlook
////////////////////////////////////////////////////////////////////////////
UINT __stdcall OutlookPath(MSIHANDLE hInstall)
{
	// Variablen definieren
	HKEY hKey = 0;
	DWORD dwBufSize = MAX_PATH;
	DWORD dwType;
	char  outlookPath[MAX_PATH] = "";
	UINT uiStat;
	
	// Existenz und Verzeichnis von Outlook auf dem System bestimmen
	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\OUTLOOK.EXE", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, &hKey )) 
	{
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, "Path", 0, &dwType, (BYTE *)&outlookPath, &dwBufSize))
		{
			// Pfad zu Outlook als Installationsverzeichnis bernehmen
			uiStat =  MsiSetProperty(hInstall, TEXT("INSTALLLOCATION"), TEXT(outlookPath));
			RegCloseKey(hKey);

			return ERROR_SUCCESS;
		}
		// Key schlieen
		RegCloseKey(hKey);
	}

	return ERROR_INSTALL_FAILURE;
}